#include <iostream>
#include <bits/stdc++.h>
using namespace std;

int main()
{
    int x, a, b;
    cin>> x;
    int niz[x];
    for(int k = 0; k < x; k++)
    {
        cin>>a>>b;
        int niz1[a], niz2[b], r, n, w;
        for(int i = 0; i < a; i++)
        {
            cin>>niz1[i];
        }
        for(int i = 0; i < b; i++)
        {
            cin>>niz2[i];
        }
        sort(niz1, niz1 + a);
        sort(niz2, niz2 + b);
        r = niz1[1]-niz1[0];
        n = niz1[0]%r;
        w = 1;
        for(int i = 0; i < a; i++)
        {
            if(niz1[i]%r != n)
            {
                w = 0;
                break;
            }
        }
        if(w == 1)
        {
            for(int i = 0; i < a; i++)
            {
                    if(niz2[i]%r == n)
                    {
                        w = 0;
                        break;
                    }
            }
        }
        niz[k] = w;
    }
    for(int i = 0; i < x;i++)
    {
        cout<<niz[i];
    }
    return 0;
}